Index: /trunk/src/sys/arch/mips/mips/locore_funcs.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/locore_funcs.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/locore_funcs.S	(revision 152)
@@ -58,4 +58,5 @@
 
 #include <sys/cdefs.h>
+#include <sys/errno.h>
 
 #include <machine/param.h>
@@ -65,4 +66,11 @@
 
 #include "assym.h"
+
+#if defined(MIPS1) || defined(MIPS2)
+#define NOP_L		nop
+#else
+#define NOP_L		/* nothing */
+#endif
+
 
 /* locore misc functions */
@@ -102,22 +110,22 @@
 	beq	a0, zero, 1f
 	 nop
-	PTR_L	a2, L_ADDR(a0)			# a2 = l->l_addr
+	PTR_L	a2, L_PCB(a0)			# a2 = l->l_addr
 	mfc0	t0, MIPS_COP_0_STATUS
 	REG_PROLOGUE
-	REG_S	s0, U_PCB_CONTEXT+SF_REG_S0(a2)
-	REG_S	s1, U_PCB_CONTEXT+SF_REG_S1(a2)
-	REG_S	s2, U_PCB_CONTEXT+SF_REG_S2(a2)
-	REG_S	s3, U_PCB_CONTEXT+SF_REG_S3(a2)
-	REG_S	s4, U_PCB_CONTEXT+SF_REG_S4(a2)
-	REG_S	s5, U_PCB_CONTEXT+SF_REG_S5(a2)
-	REG_S	s6, U_PCB_CONTEXT+SF_REG_S6(a2)
-	REG_S	s7, U_PCB_CONTEXT+SF_REG_S7(a2)
-	REG_S	t8, U_PCB_CONTEXT+SF_REG_T8(a2)
-	REG_S	sp, U_PCB_CONTEXT+SF_REG_SP(a2)
-	REG_S	s8, U_PCB_CONTEXT+SF_REG_S8(a2)
-	REG_S	ra, U_PCB_CONTEXT+SF_REG_RA(a2)
-	REG_S	t0, U_PCB_CONTEXT+SF_REG_SR(a2)
+	REG_S	s0, PCB_CONTEXT+SF_REG_S0(a2)
+	REG_S	s1, PCB_CONTEXT+SF_REG_S1(a2)
+	REG_S	s2, PCB_CONTEXT+SF_REG_S2(a2)
+	REG_S	s3, PCB_CONTEXT+SF_REG_S3(a2)
+	REG_S	s4, PCB_CONTEXT+SF_REG_S4(a2)
+	REG_S	s5, PCB_CONTEXT+SF_REG_S5(a2)
+	REG_S	s6, PCB_CONTEXT+SF_REG_S6(a2)
+	REG_S	s7, PCB_CONTEXT+SF_REG_S7(a2)
+	#REG_S	t8, PCB_CONTEXT+SF_REG_T8(a2)  # no reason to save MIPS_CURLWP
+	REG_S	sp, PCB_CONTEXT+SF_REG_SP(a2)
+	REG_S	s8, PCB_CONTEXT+SF_REG_S8(a2)
+	REG_S	ra, PCB_CONTEXT+SF_REG_RA(a2)
+	REG_S	t0, PCB_CONTEXT+SF_REG_SR(a2)
 #if defined(__mips_n32) || defined(__mips_n64)
-	REG_S	gp, U_PCB_CONTEXT+SF_REG_GP(a2)
+	REG_S	gp, PCB_CONTEXT+SF_REG_GP(a2)
 #endif
 	REG_EPILOGUE
@@ -127,6 +135,5 @@
 	 * Verify interrupt configuration matches IPL_SCHED
 	 */
-	PTR_L	t9, _C_LABEL(mips_splsw) + SPLSW_SPLCHECK
-	jalr	t9
+	jal	_C_LABEL(splcheck)
 	 nop
 #endif /* PARANOIA */
@@ -143,6 +150,4 @@
  * Switch to new context.
  */
-	.globl	_C_LABEL(__cpu_switchto_fixup)
-_C_LABEL(__cpu_switchto_fixup):
 	jal	_C_LABEL(mips_cpu_switch_resume)
 	 move	a0, MIPS_CURLWP
@@ -154,19 +159,20 @@
 	/* Check for restartable atomic sequences (RAS) */
 	PTR_L	a0, L_PROC(MIPS_CURLWP)		# argument to ras_lookup
-	PTR_L	s5, L_ADDR(MIPS_CURLWP)
+	PTR_L	s5, L_PCB(MIPS_CURLWP)
 	PTR_L	v1, P_RASLIST(a0)		# get raslist
+	NOP_L
 	beqz	v1, 1f				#   skip call if empty
 	 nop
 	jal	_C_LABEL(ras_lookup)		# ras_lookup(p, pc)
-	 PTR_L	a1, (USPACE - TF_SIZ + TF_REG_EPC)(s5)
+	 PTR_L	a1, (USPACE - TF_SIZ - CALLFRAME_SIZ + TF_REG_EPC)(s5)
 	PTR_ADDU v1, v0, 1
 	beqz	v1, 1f				# branch if v0 + 1 == 0
 	 nop
-	PTR_S	v0, (USPACE - TF_SIZ + TF_REG_EPC)(s5)
+	PTR_S	v0, (USPACE - TF_SIZ - CALLFRAME_SIZ + TF_REG_EPC)(s5)
 1:
 	/* New context is now active */
-	move	v0, s6				# Save return value
-	REG_PROLOGUE
-	REG_L	t0, U_PCB_CONTEXT+SF_REG_SR(s5)
+	move	v0, s6				# Save return value (old lwp)
+	REG_PROLOGUE
+	REG_L	t0, PCB_CONTEXT+SF_REG_SR(s5)
 #ifdef PARANOID_LOOP
 	and	t1, t0, MIPS_SR_INT_IE
@@ -176,19 +182,19 @@
 	DYNAMIC_STATUS_MASK(t0,ra)
 	move	a0, s5
-	REG_L	ra, U_PCB_CONTEXT+SF_REG_RA(a0)
-	REG_L	s0, U_PCB_CONTEXT+SF_REG_S0(a0)
-	REG_L	s1, U_PCB_CONTEXT+SF_REG_S1(a0)
-	REG_L	s2, U_PCB_CONTEXT+SF_REG_S2(a0)
-	REG_L	s3, U_PCB_CONTEXT+SF_REG_S3(a0)
-	REG_L	s4, U_PCB_CONTEXT+SF_REG_S4(a0)
-	REG_L	s5, U_PCB_CONTEXT+SF_REG_S5(a0)
-	REG_L	s6, U_PCB_CONTEXT+SF_REG_S6(a0)
-	REG_L	s7, U_PCB_CONTEXT+SF_REG_S7(a0)
-	REG_L	t8, U_PCB_CONTEXT+SF_REG_T8(a0)
+	REG_L	ra, PCB_CONTEXT+SF_REG_RA(a0)
+	REG_L	s0, PCB_CONTEXT+SF_REG_S0(a0)
+	REG_L	s1, PCB_CONTEXT+SF_REG_S1(a0)
+	REG_L	s2, PCB_CONTEXT+SF_REG_S2(a0)
+	REG_L	s3, PCB_CONTEXT+SF_REG_S3(a0)
+	REG_L	s4, PCB_CONTEXT+SF_REG_S4(a0)
+	REG_L	s5, PCB_CONTEXT+SF_REG_S5(a0)
+	REG_L	s6, PCB_CONTEXT+SF_REG_S6(a0)
+	REG_L	s7, PCB_CONTEXT+SF_REG_S7(a0)
+#	REG_L	t8, PCB_CONTEXT+SF_REG_T8(a0)	# no reason to load MIPS_CURLWP
 #if defined(__mips_n32) || defined(__mips_n64)
-	REG_L	gp, U_PCB_CONTEXT+SF_REG_GP(a0)
-#endif
-	REG_L	sp, U_PCB_CONTEXT+SF_REG_SP(a0)
-	REG_L	s8, U_PCB_CONTEXT+SF_REG_S8(a0)
+	REG_L	gp, PCB_CONTEXT+SF_REG_GP(a0)
+#endif
+	REG_L	sp, PCB_CONTEXT+SF_REG_SP(a0)
+	REG_L	s8, PCB_CONTEXT+SF_REG_S8(a0)
 	REG_EPILOGUE
 	mtc0	t0, MIPS_COP_0_STATUS
@@ -198,10 +204,9 @@
 	 * Verify interrupt configuration still matches IPL_SCHED
 	 */
-	PTR_L	t9, _C_LABEL(mips_splsw) + SPLSW_SPLCHECK
-	j	t9
+	j	_C_LABEL(splcheck)
+	 nop
 #else
-	j	ra
+	JR_HB_RA
 #endif /* PARANOIA */
-	nop
 END(cpu_switchto)
 
@@ -221,9 +226,12 @@
 #endif /* PARANOIA */
 	PTR_L	t0, L_CPU(MIPS_CURLWP)
+	NOP_L
 	INT_L	t1, CPU_INFO_MTX_COUNT(t0)
+	NOP_L
 	INT_ADDU t1, 1
 	INT_S	t1, CPU_INFO_MTX_COUNT(t0)
 	REG_L	ra, CALLFRAME_RA(sp)
 	REG_L	v0, CALLFRAME_S0(sp)		# get softint lwp
+	NOP_L
 	PTR_S	zero, L_CTXSWITCH(v0)		# clear l_ctxswtch
 #if IPL_SCHED != IPL_HIGH
@@ -244,5 +252,5 @@
 	REG_S	ra, CALLFRAME_RA(sp)		# save return address
 	.mask	0x80000000, -4
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# t0 = curlwp->l_addr
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# t0 = curlwp->l_addr
 
 	/*
@@ -258,19 +266,19 @@
 	PTR_LA	t2, softint_cleanup		# if softint blocks, return here
 	REG_PROLOGUE
-	REG_S	s0, U_PCB_CONTEXT+SF_REG_S0(t0)
-	REG_S	s1, U_PCB_CONTEXT+SF_REG_S1(t0)
-	REG_S	s2, U_PCB_CONTEXT+SF_REG_S2(t0)
-	REG_S	s3, U_PCB_CONTEXT+SF_REG_S3(t0)
-	REG_S	s4, U_PCB_CONTEXT+SF_REG_S4(t0)
-	REG_S	s5, U_PCB_CONTEXT+SF_REG_S5(t0)
-	REG_S	s6, U_PCB_CONTEXT+SF_REG_S6(t0)
-	REG_S	s7, U_PCB_CONTEXT+SF_REG_S7(t0)
-	REG_S	t8, U_PCB_CONTEXT+SF_REG_T8(t0) # MIPS_CURLWP
-	REG_S	sp, U_PCB_CONTEXT+SF_REG_SP(t0)
-	REG_S	s8, U_PCB_CONTEXT+SF_REG_S8(t0)
-	REG_S	t2, U_PCB_CONTEXT+SF_REG_RA(t0)
-	REG_S	t1, U_PCB_CONTEXT+SF_REG_SR(t0)
+	REG_S	s0, PCB_CONTEXT+SF_REG_S0(t0)
+	REG_S	s1, PCB_CONTEXT+SF_REG_S1(t0)
+	REG_S	s2, PCB_CONTEXT+SF_REG_S2(t0)
+	REG_S	s3, PCB_CONTEXT+SF_REG_S3(t0)
+	REG_S	s4, PCB_CONTEXT+SF_REG_S4(t0)
+	REG_S	s5, PCB_CONTEXT+SF_REG_S5(t0)
+	REG_S	s6, PCB_CONTEXT+SF_REG_S6(t0)
+	REG_S	s7, PCB_CONTEXT+SF_REG_S7(t0)
+	#REG_S	t8, PCB_CONTEXT+SF_REG_T8(t0) # no reason to save MIPS_CURLWP
+	REG_S	sp, PCB_CONTEXT+SF_REG_SP(t0)
+	REG_S	s8, PCB_CONTEXT+SF_REG_S8(t0)
+	REG_S	t2, PCB_CONTEXT+SF_REG_RA(t0)
+	REG_S	t1, PCB_CONTEXT+SF_REG_SR(t0)
 #if defined(__mips_n32) || defined(__mips_n64)
-	REG_S	gp, U_PCB_CONTEXT+SF_REG_GP(t0)
+	REG_S	gp, PCB_CONTEXT+SF_REG_GP(t0)
 #endif
 	REG_EPILOGUE
@@ -292,5 +300,5 @@
 	move	s3, t0					# remember curpcb
 
-	PTR_L	t2, L_ADDR(MIPS_CURLWP)
+	PTR_L	t2, L_PCB(MIPS_CURLWP)
 	move	a0, s0					# wants the pinned lwp
 	jal	_C_LABEL(softint_dispatch)
@@ -307,8 +315,8 @@
 
 	REG_PROLOGUE
-	REG_L	s0, U_PCB_CONTEXT+SF_REG_S0(s3)		# restore the saved
-	REG_L	s1, U_PCB_CONTEXT+SF_REG_S1(s3)		#    registers that we
-	REG_L	s2, U_PCB_CONTEXT+SF_REG_S2(s3)		#    used
-	REG_L	s3, U_PCB_CONTEXT+SF_REG_S3(s3)
+	REG_L	s0, PCB_CONTEXT+SF_REG_S0(s3)		# restore the saved
+	REG_L	s1, PCB_CONTEXT+SF_REG_S1(s3)		#    registers that we
+	REG_L	s2, PCB_CONTEXT+SF_REG_S2(s3)		#    used
+	REG_L	s3, PCB_CONTEXT+SF_REG_S3(s3)
 	REG_EPILOGUE
 
@@ -322,5 +330,28 @@
 
 /*
- * savectx(struct user *up)
+ * int lwp_oncpu(lwp_t *);
+ */
+LEAF(lwp_oncpu)
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get curpcb
+	li	v0, EFAULT			# assume failure
+	PTR_LA	t1, 1f				# load addr of cleanup
+	PTR_S	t1, PCB_ONFAULT(t0)		# save onfault handler
+	PTR_L	t2, L_CPU(a0)			# grab cpu of supplied lwp
+	NOP_L					# load delay
+	PTR_L	t3, CPU_INFO_CURLWP(t2)		# grab curlwp of that cpu
+	li	v0, ESRCH			# assume the lwp isn't curlwp
+	bne	a0, t3, 1f			# branch if true (not equal)
+	 nop
+	PTR_S	t2, 0(a1)			# return the cpu_info
+	li	v0, 0				# load success
+1:
+	PTR_S	zero, PCB_ONFAULT(t0)		# reset fault handler
+	j	ra				# and return.
+	 nop
+END(lwp_oncpu)
+	
+
+/*
+ * savectx(struct pcb *)
  */
 LEAF(savectx)
@@ -332,20 +363,20 @@
 #endif /* PARANOIA */
 	REG_PROLOGUE
-	REG_S	s0, U_PCB_CONTEXT+SF_REG_S0(a0)
-	REG_S	s1, U_PCB_CONTEXT+SF_REG_S1(a0)
-	REG_S	s2, U_PCB_CONTEXT+SF_REG_S2(a0)
-	REG_S	s3, U_PCB_CONTEXT+SF_REG_S3(a0)
-	REG_S	s4, U_PCB_CONTEXT+SF_REG_S4(a0)
-	REG_S	s5, U_PCB_CONTEXT+SF_REG_S5(a0)
-	REG_S	s6, U_PCB_CONTEXT+SF_REG_S6(a0)
-	REG_S	s7, U_PCB_CONTEXT+SF_REG_S7(a0)
-	REG_S	t8, U_PCB_CONTEXT+SF_REG_T8(a0)
+	REG_S	s0, PCB_CONTEXT+SF_REG_S0(a0)
+	REG_S	s1, PCB_CONTEXT+SF_REG_S1(a0)
+	REG_S	s2, PCB_CONTEXT+SF_REG_S2(a0)
+	REG_S	s3, PCB_CONTEXT+SF_REG_S3(a0)
+	REG_S	s4, PCB_CONTEXT+SF_REG_S4(a0)
+	REG_S	s5, PCB_CONTEXT+SF_REG_S5(a0)
+	REG_S	s6, PCB_CONTEXT+SF_REG_S6(a0)
+	REG_S	s7, PCB_CONTEXT+SF_REG_S7(a0)
+	REG_S	t8, PCB_CONTEXT+SF_REG_T8(a0)	# MIPS_CURLWP
 #if defined(__mips_n32) || defined(__mips_n64)
-	REG_S	gp, U_PCB_CONTEXT+SF_REG_GP(a0)
-#endif
-	REG_S	sp, U_PCB_CONTEXT+SF_REG_SP(a0)
-	REG_S	s8, U_PCB_CONTEXT+SF_REG_S8(a0)
-	REG_S	ra, U_PCB_CONTEXT+SF_REG_RA(a0)
-	REG_S	v0, U_PCB_CONTEXT+SF_REG_SR(a0)
+	REG_S	gp, PCB_CONTEXT+SF_REG_GP(a0)
+#endif
+	REG_S	sp, PCB_CONTEXT+SF_REG_SP(a0)
+	REG_S	s8, PCB_CONTEXT+SF_REG_S8(a0)
+	REG_S	ra, PCB_CONTEXT+SF_REG_RA(a0)
+	REG_S	v0, PCB_CONTEXT+SF_REG_SR(a0)
 	REG_EPILOGUE
 	j	ra
@@ -369,5 +400,5 @@
 	REG_S	s6, SF_REG_S6(a0)
 	REG_S	s7, SF_REG_S7(a0)
-	REG_S	t8, SF_REG_T8(a0)
+	#REG_S	t8, SF_REG_T8(a0)	# no reason to save MIPS_CURLWP
 #if defined(__mips_n32) || defined(__mips_n64)
 	REG_S	gp, SF_REG_GP(a0)
@@ -395,5 +426,5 @@
 	REG_L	s6, SF_REG_S6(a0)
 	REG_L	s7, SF_REG_S7(a0)
-	REG_L	t8, SF_REG_T8(a0)
+	#REG_L	t8, SF_REG_T8(a0)		# no reason to load MIPS_CURLWP
 #if defined(__mips_n32) || defined(__mips_n64)
 	REG_L	gp, SF_REG_GP(a0)
@@ -405,10 +436,10 @@
 	COP0_SYNC
 	j	ra
-	li	v0, 1
+	 li	v0, 1
 END(longjmp)
 #endif
 
 /*
- * u_int32_t mips_cp0_cause_read(void)
+ * uint32_t mips_cp0_cause_read(void)
  *
  *	Return the current value of the CP0 Cause register.
@@ -420,9 +451,9 @@
 	mfc0	v0, MIPS_COP_0_CAUSE
 	j	ra
-	nop
+	 nop
 END(mips_cp0_cause_read)
 
 /*
- * void mips_cp0_cause_write(u_int32_t)
+ * void mips_cp0_cause_write(uint32_t)
  *
  *	Set the value of the CP0 Cause register.
@@ -430,14 +461,10 @@
 LEAF(mips_cp0_cause_write)
 	mtc0	a0, MIPS_COP_0_CAUSE
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips_cp0_cause_write)
 
 
 /*
- * u_int32_t mips_cp0_status_read(void)
+ * uint32_t mips_cp0_status_read(void)
  *
  *	Return the current value of the CP0 Status register.
@@ -450,5 +477,5 @@
 
 /*
- * void mips_cp0_status_write(u_int32_t)
+ * void mips_cp0_status_write(uint32_t)
  *
  *	Set the value of the CP0 Status register.
@@ -460,9 +487,5 @@
 LEAF(mips_cp0_status_write)
 	mtc0	a0, MIPS_COP_0_STATUS
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	nop
+	JR_HB_RA
 END(mips_cp0_status_write)
 
@@ -470,21 +493,13 @@
 /*----------------------------------------------------------------------------
  *
- * MachFPInterrupt --
- * MachFPTrap --
+ * mips_fpu_intr --
+ * mips_fpu_trap --
  *
  *	Handle a floating point interrupt (r3k) or trap (r4k).
  *	the handlers are indentical, only the reporting mechanisms differ.
  *
- *	MachFPInterrupt(status, cause, pc, frame)
- *		unsigned status;
- *		unsigned cause;
- *		unsigned pc;
- *		int *frame;
- *
- *	MachFPTrap(status, cause, pc, frame)
- *		unsigned status;
- *		unsigned cause;
- *		unsigned pc;
- *		int *frame;
+ *	mips_fpu_intr(vaddr_t pc, struct trapframe *tf)
+ *
+ *	mips_fpu_trap(vaddr_t pc, struct trapframe *tf)
  *
  * Results:
@@ -496,6 +511,6 @@
  *----------------------------------------------------------------------------
  */
-NESTED(MachFPInterrupt, CALLFRAME_SIZ, ra)
-XNESTED(MachFPTrap)
+NESTED(mips_fpu_intr, CALLFRAME_SIZ, ra)
+XNESTED(mips_fpu_trap)
 	.mask	0x80000000, -4
 	PTR_SUBU	sp, CALLFRAME_SIZ
@@ -506,4 +521,8 @@
 	COP0_HAZARD_FPUENABLE
 
+	REG_PROLOGUE
+	REG_L           a2, TF_REG_CAUSE(a1)
+	REG_EPILOGUE
+
 	cfc1		t0, MIPS_FPU_CSR	# stall til FP done
 	cfc1		t0, MIPS_FPU_CSR	# now get status
@@ -511,29 +530,17 @@
 	sll		t2, t0, (31 - 17)	# unimplemented operation?
 	bgez		t2, 3f			# no, normal trap
-	nop
-/*
- * We got an unimplemented operation trap so
- * We received an unimplemented operation trap.
+	 nop
+/*
+ * We received an unimplemented operation trap so
+ * fetch the instruction and emulate the instruction.
  *
  * We check whether it's an unimplemented FP instruction here rather
- * than invoking MachEmulateInst(), since it is faster.
- *
- * fetch the instruction and emulate the instruction.
- */
-	bgez		a1, 1f			# Check the branch delay bit.
-	nop
-/*
- * The instruction is in the branch delay slot.
- */
-	b		2f
-	lw		a0, 4(a2)		# a0 = coproc instruction
-/*
- * This is not in the branch delay slot so calculate the resulting
- * PC (epc + 4) into v0 and continue to MachEmulateFP().
- */
-1:
-	lw		a0, 4(a2)		# a0 = coproc instruction
-2:
-	move		a2, a1
+ * than invoking mips_emul_inst(), since it is faster.
+ */
+	srl		v1, a2, 31		# move branch delay bit to LSB
+	sll		v1, 2			# shift it left by 2 (mult by 4)
+	PTR_ADDU	a0, v1			# add to a0
+	INT_L		a0, 0(a0)		# a0 = coproc instruction
+	NOP_L					# load delay
 
 /*
@@ -541,24 +548,27 @@
  * instruction.
  */
-	srl		t0, a0, MIPS_OPCODE_SHIFT
-	beq		t0, MIPS_OPCODE_C1, 4f
-	nop
-
-/*
- * Send a floating point exception signal to the current LWP.
- */
-	li		t0, 0xFFFFFF00
-	and		a1, a1, t0
-	ori		a1, a1, T_RES_INST << MIPS_CR_EXC_CODE_SHIFT
-	REG_PROLOGUE
-	REG_S		a1, TF_REG_CAUSE(a3)
-	REG_EPILOGUE
+	srl		t2, a0, MIPS_OPCODE_SHIFT
+	beq		t2, MIPS_OPCODE_C1, 4f
+	 nop
+
+/*
+ * Send an ILL signal to the current LWP if the instruction can't be emulated.
+ */
+	srl		a2, 8
+	sll		a2, 8
+	ori		a2, T_RES_INST << MIPS_CR_EXC_CODE_SHIFT
+	REG_PROLOGUE
+	REG_S		a2, TF_REG_CAUSE(a1)
+	REG_EPILOGUE
+
+	and		t2, t0, ~MIPS_FPU_EXCEPTION_BITS
+	ctc1		t2, MIPS_FPU_CSR
 
 	move		a1, a0				# code = instruction
 	jal		_C_LABEL(mips_fpuillinst)
-	move		a0, MIPS_CURLWP			# get current LWP
+	 move		a0, MIPS_CURLWP			# get current LWP
 
 	b		FPReturn
-	nop
+	 nop
 
 /*
@@ -568,5 +578,5 @@
 3:
 	REG_PROLOGUE
-	REG_S		a1, TF_REG_CAUSE(a3)
+	REG_S		a2, TF_REG_CAUSE(a1)
 	REG_EPILOGUE
 
@@ -576,15 +586,16 @@
 	move		a1, t0			# FPU status
 	jal		_C_LABEL(mips_fpuexcept)
-	move		a0, MIPS_CURLWP		# get current LWP
+	 move		a0, MIPS_CURLWP		# get current LWP
 
 	b		FPReturn
-	nop
-
-/*
- * Finally, we can call MachEmulateFP() where a0 is the instruction to emulate.
+	 nop
+
+/*
+ * Finally, we can call
+ * mips_emul_fp(uint32_t insn, struct trapframe *tf, uint32_t cause).
  */
 4:
-	jal		_C_LABEL(MachEmulateFP)
-	move		a1, a3
+	jal		_C_LABEL(mips_emul_fp)
+	 nop
 
 /*
@@ -594,10 +605,10 @@
 	mfc0		t0, MIPS_COP_0_STATUS
 	REG_L		ra, CALLFRAME_RA(sp)
-	and		t0, t0, ~MIPS_SR_COP_1_BIT
+	and		t0, ~MIPS_SR_COP_1_BIT
 	mtc0		t0, MIPS_COP_0_STATUS
 	COP0_SYNC
 	j		ra
-	PTR_ADDU	sp, CALLFRAME_SIZ
-END(MachFPInterrupt)
+	 PTR_ADDU	sp, CALLFRAME_SIZ
+END(mips_fpu_intr)
 #endif /* !defined(NOFPU) || defined(FPEMUL) */
 
@@ -638,5 +649,5 @@
 /* We can always safely store a 64-bit zero on MIPS3,4,64 */
 	.set	push
-#if !defined(MIPS1) && !defined(MIPS32)
+#if (MIPS1 + MIPS32 + MIPS32R2) == 0
 	.set	mips3
 #endif
Index: /trunk/src/sys/arch/mips/mips/locore_mips1.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: locore_mips1.S,v 1.64.26.1.2.9 2010/02/23 20:33:48 matt Exp $	*/
+/*	$NetBSD: locore_mips1.S,v 1.64.26.1.2.13 2011/04/29 08:26:26 matt Exp $	*/
 
 /*
@@ -9,5 +9,5 @@
  *
  * Redistribution and use in source and binary forms, with or without
- * modification, are permited provided that the following conditions
+ * modification, are permitted provided that the following conditions
  * are met:
  * 1. Redistributions of source code must retain the above copyright
@@ -61,11 +61,26 @@
 #include "assym.h"
 
+#define	_SLLV		sllv
+
+#define	_SLL		sll
+#define	_SRL		srl
+#define	WIRED_SHIFT	2
+
+/*
+ * Use correct-sized m?c0/dm?c0 opcodes.
+ */
+#define	_MFC0	mfc0
+#define	_MTC0	mtc0
+
+
+#define MIPSX(name)	__CONCAT(mips1_,name)
+
 	.set	noreorder
 	.text
 
-EXPORT(mips1_exceptionentry_start)
-
-/*
- * mips1_utlb_miss
+EXPORT(MIPSX(exceptionentry_start))
+
+/*
+ * mipsN_utlb_miss
  *
  * A reference is made (in either kernel or user mode) to a page in
@@ -74,38 +89,41 @@
  * No pc relative jump instruction is allowed.
  */
-VECTOR(mips1_utlb_miss, unknown)
+VECTOR(MIPSX(utlb_miss), unknown)
 	.set	noat
-	mfc0	k0, MIPS_COP_0_BAD_VADDR	# get the virtual address
-	lw	k1, CPUVAR(PMAP_SEGBASE)	# get the current segment table
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	#00: k0=bad address
+	lui	k1, %hi(CPUVAR(PMAP_SEG0TAB))	#01: k1=hi of seg0tab
 	bltz	k0, 1f				# R3000 chip bug
-	srl	k0, k0, SEGSHIFT		# compute segment table index
-	sll	k0, k0, 2
-	addu	k1, k1, k0
-	mfc0	k0, MIPS_COP_0_BAD_VADDR	# get the virtual address
-	lw	k1, 0(k1)			# get pointer to segment map
-	srl	k0, k0, PGSHIFT - 2		# compute segment map index
-	and	k0, k0, (NPTEPG - 1) << 2
-	beq	k1, zero, 2f			# invalid segment map
-	addu	k1, k1, k0			# index into segment map
-	lw	k0, 0(k1)			# get page PTE
-	nop
-	beq	k0, zero, 2f			# dont load invalid entries
-	mtc0	k0, MIPS_COP_0_TLB_LOW
-	nop
-	tlbwr					# update TLB
+	 PTR_SRL k0, 1*(PGSHIFT-PTR_SCALESHIFT)+(PGSHIFT-2)#03: k0=seg offset (almost)
+	PTR_L	k1, %lo(CPUVAR(PMAP_SEG0TAB))(k1) #04: k1=seg0tab 
+	andi	k0, (NBPG-(1<<PTR_SCALESHIFT))	#07: k0=seg offset (mask 0x3)
+	PTR_ADDU k1, k0				#08: k1=seg entry address
+	PTR_L	k1, 0(k1)			#09: k1=seg entry
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	#0a: k0=bad address (again)
+	beqz	k1, MIPSX(nopagetable)		#0b: ==0 -- no page table
+	 PTR_SRL k0, (PGSHIFT-2)		#0c: k0=VPN (aka va>>10)
+	andi	k0, (NBPG-4)			#0d: k0=page table offset
+	PTR_ADDU k1, k0				#0e: k1=pte address
+	INT_L	k0, 0(k1)			#0f: k0=lo0 pte
+	nop					#10: load delay
+	beqz	k0, MIPSX(invalidpte)		#11: dont load invalid entries
+	 nop					#12  branch delay
+	mtc0	k0, MIPS_COP_0_TLB_LOW		#13: lo0 is loaded
+	nop					#14: load delay
+	tlbwr					#15: update TLB
 1:
-	mfc0	k1, MIPS_COP_0_EXC_PC		# get return address
-	nop
-	j	k1
-	rfe
-2:
-	j	mips1_slowfault			# handle the rest
-	nop
+	_MFC0	k1, MIPS_COP_0_EXC_PC		#16: get return address
+	nop					#17: load delay
+	j	k1				#18: return from
+	 rfe					#19:    exception
+MIPSX(nopagetable):
+MIPSX(invalidpte):
+	j	MIPSX(slowfault)		#1a: handle the rest
+	 nop					#1b: branch delay
 	.set	at
-VECTOR_END(mips1_utlb_miss)
-
-
-/*
- * mips1_exception
+VECTOR_END(MIPSX(utlb_miss))
+
+
+/*
+ * mipsN_exception
  *
  * Handles any exceptions other than reset and UTLB miss.  This routine
@@ -113,51 +131,59 @@
  * instructions.  No pc relative jump instruction is allowed.
  */
-VECTOR(mips1_exception, unknown)
+	.org	MIPSX(utlb_miss) + 0x80
+VECTOR(MIPSX(exception), unknown)
 /*
  * Find out what mode we came from and jump to the proper handler.
  */
 	.set	noat
-	mfc0	k0, MIPS_COP_0_STATUS		# get the status register
-	mfc0	k1, MIPS_COP_0_CAUSE		# get the cause register
-	and	k0, k0, MIPS1_SR_KU_PREV	# test for user mode
-	sll	k0, k0, 4			# shift user bit for cause index
-	and	k1, k1, MIPS1_CR_EXC_CODE	# mask out the cause bits
-	or	k1, k1, k0			# change index to user table
-1:
-	la	k0, mips1_excpt_sw		# get base of the jump table
-	addu	k0, k0, k1			# get the address of the
+	mfc0	k0, MIPS_COP_0_STATUS		#00: get the status register
+	mfc0	k1, MIPS_COP_0_CAUSE		#01: get the cause register
+	and	k0, MIPS1_SR_KU_PREV		#02: test for user mode
+	sll	k0, 4				#03: shift user bit for cause index
+	and	k1, MIPS1_CR_EXC_CODE		#04: mask out the cause bits
+	or	k1, k0				#05: change index to user table
+	PTR_LA	k0, MIPSX(excpt_sw)		#06: get base of the jump table
+	PTR_ADDU k0, k1				#08: get the address of the
 						#  function entry.  Note that
 						#  the cause is already
 						#  shifted left by 2 bits so
-						#  we dont have to shift
-	lw	k0, 0(k0)			# get the function address
-	nop
-	lw	k1, CPUVAR(CURLWP)		# get the current lwp
-	j	k0				# jump to the function
-	nop
+						#  we dont have to shift.
+	PTR_L	k0, 0(k0)			#09: get the function address
+	nop					#0a: load delay
+	j	k0				#0b: jump to the function
+	 nop					#0c
+	nop					#0d
+	nop					#0e
+	nop					#0f
 	.set	at
-VECTOR_END(mips1_exception)
-
-
-/*
- * mips1_SlowFault
- *
- * UTLBMiss handler could not find out a TLB entry for the user process.
- * Dispatch a general case exception handler.
- */
-mips1_slowfault:
+VECTOR_END(MIPSX(exception))
+
+
+/*----------------------------------------------------------------------------
+ *
+ * mipsN_slowfault
+ *
+ * Alternate entry point into the mipsN_user_gen_exception or
+ * mipsN_kern_gen_exception, when the UTLB miss handler couldn't
+ * find a TLB entry.
+ *
+ * Find out what mode we came from and call the appropriate handler.
+ *
+ *----------------------------------------------------------------------------
+ */
+MIPSX(slowfault):
 	.set	noat
-	mfc0	k1, MIPS_COP_0_STATUS
-	la	k0, _C_LABEL(mips1_kern_gen_exception)
-	and	k1, k1, MIPS1_SR_KU_PREV
-	beq	k1, zero, 1f
-	nop
-	la	k0, _C_LABEL(mips1_user_gen_exception)
-1:	j	k0
-	nop
+	mfc0	k0, MIPS_COP_0_STATUS
+	nop
+	and	k0, MIPS1_SR_KU_PREV
+	bnez	k0, _C_LABEL(MIPSX(user_gen_exception))
+	 nop
 	.set	at
-
-/*
- * mips1_kern_gen_exception
+/*
+ * Fall through ...
+ */
+
+/*
+ * mipsN_kern_gen_exception
  *
  * Handle an exception during kernel mode.
@@ -165,19 +191,30 @@
  * call trap() to process the condition.
  *
- * trapframe is now pointed by 5th arg {
+ * trapframe is pointed to by the 5th arg and a dummy sixth argument is used
+ * to avoid alignment problems
+ * {
  *	register_t cf_args[4 + 1];
- *	register_t cf_pad;
+ *	register_t cf_pad;		(for 8 word alignment)
  *	register_t cf_sp;
  *	register_t cf_ra;
- *	mips_reg_t tf_regs[17];		- trapframe begins here
- * 	mips_reg_t tf_sr;		-
- * 	mips_reg_t tf_mullo;		-
- * 	mips_reg_t tf_mulhi;		-
- * 	register_t tf_epc;		- may be changed by trap() call
+ *	struct reg cf_tf;
  * };
  */
-NESTED_NOPROFILE(mips1_kern_gen_exception, KERNFRAME_SIZ, ra)
+NESTED_NOPROFILE(MIPSX(kern_gen_exception), KERNFRAME_SIZ, ra)
 	.set	noat
 	.mask	0x80000000, -4
+#ifdef PARANOIA
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	nop
+	slt	k0, k0, sp		# k0 = L_PCB(MIPS_CURLWP) < sp
+1:	beqz	k0, 1b			# loop forever if false
+	 nop
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	nop
+	PTR_ADDU k0, USPACE
+	slt	k0, sp, k0		# k0 = sp < L_PCB(MIPS_CURLWP) + USPACE
+2:	beqz	k0, 2b			# loop forever if false
+	 nop
+#endif /* PARANOIA
 /*
  * Save the relevant kernel registers onto the stack.
